# Copyright 2017 Cumulus Networks, Inc.  All Rights reserved.
#
# This software is subject to the Cumulus Networks End User License Agreement
# available at the following locations:
#
# Internet: https://cumulusnetworks.com/downloads/eula/latest/view/
# Cumulus Linux systems: /usr/share/cumulus/EULA.txt

from __future__ import absolute_import

import subprocess
import os
from netq_lib.orm.redisdb.models import License
from netq_lib.common.enums import Platform


def process_cl_license(output, svc_failed=False, **kwargs):
    fnull = open(os.devnull, 'w')
    license_obj = License()
    license_obj.name = Platform.CL
    platform = kwargs.get('platform', '')
    license_obj.license = ''
    license_obj.state = 'N/A'

    if 'cumulus' in platform:
        try:
            license_obj.license = subprocess.check_output(
                ['/usr/cumulus/bin/cl-license', ], stderr=fnull)
        except (subprocess.CalledProcessError, OSError):
            pass
        if svc_failed == 0:
            license_obj.state = 'ok'
        elif svc_failed == 1:
            license_obj.state = 'missing'
        else:
            license_obj.state = 'invalid'
    license_obj.save()
    return 0
